unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, EditBtn,
  StdCtrls, Buttons;

type

  { TForm1 }

  TForm1 = class(TForm)
   Button1: TButton;
   Button2: TButton;
   DirectoryEdit1: TDirectoryEdit;
   DirectoryEdit2: TDirectoryEdit;
   FileNameEdit1: TFileNameEdit;
   FileNameEdit2: TFileNameEdit;
   Label1: TLabel;
   Label2: TLabel;
   Label3: TLabel;
   Label4: TLabel;
   procedure Button1Click(Sender: TObject);
   procedure Button2Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }

uses StrUtils;

Procedure ConvertFile(InF,OutF:string);
Var InFile,OutFile:file of byte;
    b:byte;
    i:longint;
    fname,ext:string;
begin
     AssignFile(OutFile,OutF);
     rewrite(OutFile);
     AssignFile(InFile,InF);
     Reset(InFile);
     fname:=format('%-8.8s',[UpperCase(ExtractWord(1,ExtractFileName(InF),['.']))]);
     ext:=UpperCase(ExtractWord(2,ExtractFileName(InF),['.']));
     // typ
     Write(OutFile,$22);
     // jmeno
     for i:=1 to 8 do begin
         write(outFile,ord(fname[i]));
         end;
     write(outFile,ord('.'));
     for i:=1 to 3 do begin
         write(outFile,ord(ext[i]));
         end;
     write(outFile,$0d);
     for i:=1 to 4 do begin
         write(outFile,$00);
         end;
     // delku
     write(outFile,FileSize(InFile) mod 256);
     write(outFile,FileSize(InFile) div 256);
     // start Addr
     write(outFile,$01);
     write(outFile,$00);
     // exec Addr
     write(outFile,$00);
     write(outFile,$00);
     // comment
     for i:=1 to 104 do begin
         write(outFile,$00);
         end;
     // data
     for i:=1 to filesize(InFile) do begin
         Read(InFile,b);
         Write(OutFile,b);
         end;
     closeFile(OutFile);
     closeFile(InFile);
     end;


procedure TForm1.Button1Click(Sender: TObject);
begin
     Button1.Enabled:=False;
     ConvertFile(FileNameEdit1.FileName,FileNameEdit2.FileName);
     Button1.Enabled:=True;
     end;

procedure TForm1.Button2Click(Sender: TObject);
var sr:tSearchRec;

begin
     Button2.Enabled:=False;
     If FindFirst(DirectoryEdit1.Directory+'\*.*',faAnyFile-faDirectory,SR)=0 then begin
        Repeat
              ConvertFile(DirectoryEdit1.Directory+'\'+sr.name,DirectoryEdit2.Directory+'\'+ExtractFileName(sr.name)+'.MZF');
              until FindNext(sr)<>0;
        end;
     Button2.Enabled:=True;
     end;

initialization
  {$I Unit1.lrs}

end.

